<?php
#=
/*
Copyright 2002-2004, Daniel Deycard, Jacques Messines, Alain Pomirol
(CATICE Académie de Bordeaux)

This file is part of GiBii/Melia.
GiBii/Melia is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

GiBii/Melia is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GiBii/Melia; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

include("../include/vars_adm.php");
include("../include/util.inc.php");
include("../include/utiljs.php");
include("../backup/guide.inc.php");

@session_start();
recupvars(); //globalise les variables de session mais elles sont inacessibles

//vider un établissement (sauf la table etablissements)
function delrecords($etab_id) {
global $db;
//on ne se sert pas des facilités du DELETE de MySQL >= 4.0.0
$res=query("SELECT prof_id FROM profs WHERE etab_id=$etab_id");
while (list($pid)=mysql_fetch_array($res)) {
    query("DELETE FROM reponses WHERE prof_id=$pid");
    query("DELETE FROM lien_profs_classes WHERE prof_id=$pid");
    query("DELETE FROM lpi WHERE prof_id=$pid");
}
$res=query("SELECT eleve_id FROM eleves WHERE etab_id=$etab_id");
while (list($eid)=mysql_fetch_array($res)) {
    query("DELETE FROM demandes WHERE eleve_id=$eid");
    query("DELETE FROM resultats WHERE eleve_id=$eid");
    query("DELETE FROM lien_eleves_disciplines WHERE eleve_id=$eid");
    query("DELETE FROM lien_eleves_classes WHERE eleve_id=$eid");
}
query("DELETE FROM eleves WHERE etab_id=$etab_id");
query("DELETE FROM profs WHERE etab_id=$etab_id");
query("DELETE FROM comptes WHERE etab_id=$etab_id");
query("DELETE FROM classes WHERE etab_id=$etab_id");
if (table_dans_base('divers',$db)) query("DELETE FROM divers WHERE etab_id=$etab_id");

}

function choisir() {
global $etab_rne, $HIDEDATA;
$PHP_SELF=basename($_SERVER['PHP_SELF']);
print "<hr><p class=\"sous_sous_titre\">Indiquez un fichier de backup (extensions sql, gz et bz2 acceptées)</p>";
print "<br />";
print "<center><FORM method=\"post\" action=\"$PHP_SELF\" enctype=\"multipart/form-data\">\n";
print "<p >\n";
print "Sélectionnez le fichier qu'un précédent backup vous a fourni : ";
print "<input type=\"file\" name=\"fichier\">";
print "<input type=\"hidden\" name=\"MAX_FILE_SIZE\" VALUE=\"8000000\">";
print "<br /><br />\n";
print "<input type='submit' class='coul' name='bouton' value='Restaurer'>\n";
print "</FORM>\n";
print "</p></center>\n";
$rep="$HIDEDATA/$etab_rne/backup/";
$handle=opendir(creertousrep($rep));
$nb=0;
//on ne fait afficher le tableau et son en-tête que s'il n'est pas vide
//doù le passage sans affichage
$aff='';
@setlocale(LC_TIME, "fr_FR", "FRA", 'france', 'french');
while ($file=readdir($handle)) {
    $nomcomplet=$rep.$file;
    if ($file!='.' && $file!='..' && is_file($nomcomplet)) {
        $p=strrpos($file,'.');
        if ($p!==false) $ext=strtolower(substr($file,$p+1));
        else $ext='';
        if ($ext=='sql' || $ext=='gz' || $ext=='bz2') {
            $aff.="<tr><td><a href=\"$PHP_SELF?bouton=1&srvfic=".urlencode($nomcomplet)."\">
                   &nbsp;$file</a></td>\n";
            $stats=stat($nomcomplet);
            $taille=round($stats[7]/1024);
            $date=strftime('%A %d %B %Y à %H:%M:%S',$stats[9]);
            $aff.="<td style=\"text-align=center\"> $taille </td>\n"; //taille en Koctets

            $aff.="<td>&nbsp; $date </td>\n"; //date dernière modif
            $aff.="</tr>\n";
            $nb++;
        }
    }
}

if ($nb>0)
   print "<br /><br />";
   print "<p class=\"sous_sous_titre\">Vous pouvez aussi sélectionner un fichier dans la liste
          ci-dessous (fichiers stockés sur le serveur) :</p>";
   print "<div align='center'><table width=\"90%\" border='1'>\n";
   print "<tr class='rubrique'><td width=\"40%\"> Fichier </td>
          <td width=\"20%\"> Taille (Ko)</td>

          <td > Date </td></tr>\n";
   print $aff;
   print "</table></div>\n";

}

function erreur($mess) {   //pour le 2e passage
alert($mess);
gohistory(-1);
print "</body></html>";
exit();
}

function chksum_verif($nom) {
global $crlf;
$modele_cs='# checksum=';
$fp=fopen($nom,"r");
if (!$fp) return "impossible d'ouvrir le fichier en lecture (s'il existe !)";
$csfic=0;
$contenu='';
while (!feof($fp) && !$csfic) {
    $ligne=fgets($fp,1024);
    $m=strpos($ligne,$modele_cs);
    if ($m!==0) $contenu.=$ligne;
    else
        $csfic=substr($ligne,$m+strlen($modele_cs));
}
if ($csfic!=crc32($contenu)) return "somme de contrôle incorrecte";
return "";
}

function enregistrer() {
global $etab_rne, $HIDEDATA;
$erreur="";
$copies="";
$infosfichier=$_FILES['fichier'];
//print_r($infosfichier);print "<br>";
$nom=strtolower($infosfichier['name']);
if (empty($nom)) erreur('Pas de fichier indiqué !');
$type=$infosfichier['type'];
$tmp_name=$infosfichier['tmp_name'];

$size=$infosfichier['size'];
$error=$infosfichier['error'];
if ($tmp_name=='none' || $size==0) erreur("Le fichier n'existe pas ou a une taille nulle ou trop importante.");
if ($error) erreur("Erreur $error pour $nom (tmp_name=$tmp_name)");
$dest="$HIDEDATA/$etab_rne/backup/$nom";
if (!move_uploaded_file($tmp_name,creertousrep($dest))) erreur("Erreur de copie vers $dest.");
return $dest;
}

function decompresser($nomfichier) {
global $etab_id, $etab_rne, $HIDEDATA;
if (ereg("\.(bz2|gz|sql)$" , $nomfichier, $cr)) {
	  $represtore="$HIDEDATA/$etab_rne";
	  creertousrep($represtore);
    $restore=$represtore.'/'.$etab_id.'_'.date('Ymd').'.sql';
    switch ($cr[1]) {
        case 'bz2':
             $fbz2=bzopen($nomfichier,'r');
             $fsql=fopen($restore,'w');
             while ($s=bzread($fbz2,10000)) fwrite($fsql,$s);
             fclose($fsql);
             bzclose($fbz2);
             break;
        case 'gz':
             $fgz=gzopen($nomfichier,'r');
             $fsql=fopen($restore,'w');
             while ($s=gzread($fgz,10000)) fwrite($fsql,$s);
             fclose($fsql);
             gzclose($fgz);
             break;
        case 'sql':
             $restore=$nomfichier;
             break;
    }

    $cstheorique=substr(basename($nomfichier),0,6);
    $csreel=substr(md5_file($restore),0,6);
    print "Check-sum théorique : $cstheorique<br>";
    print "Check-sum réelle    : $csreel<br>";
    if ($cstheorique!=$csreel) erreur("Contenu du fichier incorrect : la somme de contrôle ne convient pas.");

}
else $restore="";
return $restore;
}

function majforeign($set,&$paramspasse) {
global $eleve_id,$prof_id,$message_id,$classe_id; //tableaux de conversion des clés primaires
//$paramspasse=array('eleve_id','prof_id') ou array('eleve_id') ou... array()
foreach($paramspasse as $nomforeign) {
    //$nomforeign='eleve_id'
    //global $$nomforeign; // globalise le tableau $eleve_id[]
    $cnv=&$$nomforeign; // si $nomforeign='eleve_id', $cnv pointe[] comme $eleve_id[]
    //remplacer par ex. eleve_id=4 par eleve_id=123, où 123=$eleve_id[4]
    $cherche=$nomforeign.'=';
    //ci-dessous : c'était très beau... mais erreur si pb dans la base (par exemple un reponse_id sans message_id : cnv[message_id] n'est pas défini)
    // $set=preg_replace("/$cherche-(\d+)/e","'$cherche'.\$cnv[$1]",$set);
    //donc on découpe en deux temps
    if (preg_match("/$cherche-(\d+)/e",$set,$capture)) {
        if (isset($cnv[$capture[1]]))
            $valrempl=$cnv[$capture[1]];
        else //c'est ce qui posait problème
            $valrempl='0';
        $set=preg_replace("/$cherche-(\d+)/e","'$cherche'.\$valrempl",$set);
        }
}
//print $set."<br>";
return $set;
}


function restore_passe1() {
global $guide, $etab_id, $tini,
       $eleve_id,$prof_id,$compte_id,$message_id, //tableaux de conversion des clés primaires
       $db, $VERSION_GIBII;

print "<h2>Passe 1 : enregistrement provisoire dans la base</h2>";

//récupérer la seule ligne de la section [etablissements] (peut-on faire sans le foreach ?)
print "<h3>Table etablissements</h3>";
foreach($tini['etablissements'] as $oldetabid => $set) ;
//Afficher les caractérisqtiques de l'étab du fichier backup
print "<b>Ancien numéro</b> : $oldetabid";print "<br /><br />";
$set=urldecode($set);

//if ($oldetabid==$etab_id)  {
//suppression dans tous les cas sinon pb avec une restauration réitérée.
    //supprimer tous les enregistrements relatifs à etab_id
    //sauf celui de la table etablissements
delrecords($etab_id);

$sql="UPDATE etablissements SET $set WHERE etab_id=$etab_id";
print $sql;print "<br />";
query($sql);
$numetab=$etab_id;          //le nom 'numetab' est IMPOSÉ par le backup

//à partir d'ici, on peut considérer qu'on fait un restore dans un autre site
//Balayer les tables de l'INI
//$bkup4=false; //pour savoir si la table lien_eleves_classes existait dans le backup
foreach($tini as $table => $contenu) {  //par ex. $table='eleves'  (une section de l'ini)
	if ($table=='#') continue;
    if ($table=='etablissements') continue;
    //provisoire pour certains backups erronés (dans le guide, la PRIMARY KEY avait été oubliée)
    if ($table=='erreurs_logins') continue;
    if (!table_dans_base($table,$db)) continue; //notamment pour la table divers, créée à la volée 

    print "<h3>Table $table</h3>";
    $params=$guide[$table];         //par ex. array('cle'   => 'eleve_id',
                                    //                            'garder'=> true ,
    $nomid=$params['cle'];          //par ex. eleve_id
    $garder=$params['garder'];
    $paramspasse1=$params['passe1'];
    if ($params['etab']) $queueinsert=",etab_id=$numetab";
    else $queueinsert="";
    if ($garder) {
        //créer un tableau de conversions
        global $$nomid;                //par ex. global $eleves
        $conv=&$$nomid;                //$t[] pointe la même chose que $eleve_id[]
        $conv['NULL']='NULL';          //pour le cas de la table comptes et des champs eleve_id et prof_id
    }
    $is_personne=($table=='eleves' || $table=='profs');
    //balayer les lignes de la table
    foreach($contenu as $nid => $ligne) {
        $set=urldecode($ligne);
        $set=majforeign($set,$paramspasse1);
        if ($is_personne) $set=str_replace(',tag=NULL,',',tag=0,',$set);
        $sql="INSERT INTO $table SET ".$set.$queueinsert;

		//$ok=filtrer//verrue palliant les pb dans les tables

        query($sql);
        print $sql;print "<br />";
        if ($garder) {
           $conv[$nid]=mysql_insert_id();  //pour la conversion ancien->nouveau
           print "&nbsp;&nbsp;&nbsp;-> ${nomid}[$nid]=".$conv[$nid]."<br /><br />";
            }
        }
    }
/*
if (!$bkup4) {
    //la table liens_profs_classes n'existait pas dans le backup : il faut la remplir "à la main"
    print "<br />";print "<br />";
    print "Création des enregistrements de la table <b>lien_profs_classes</b> qui n'existait pas dans le backup fourni.";
    print "<br />";
    query("INSERT INTO lien_eleves_classes (eleve_id,classe_id)
            SELECT eleve_id,classe_id FROM eleves WHERE etab_id=$numetab");
    }
*/
print "<hr>\n";
return $numetab;
}


function restore_passe2($numetab) {
global $tini, $guide, $etab_id,
	   $db,	
       $eleve_id,$prof_id,$compte_id,$message_id; //tableaux de conversion des clés primaires
print "<h2>Passe 2 : mise à jour des clés étrangères</h2>";
foreach($tini as $table => $contenu) {  //par ex. $table='eleves'
	if ($table=='#') continue;
    if (!table_dans_base($table,$db)) continue; //notamment pour la table divers, créée à la volée 
	
    $params=$guide[$table];             //par ex. array('cle'   => 'eleve_id',
                                        //              'garder'=> true ,
    //dans cette passe, on fait un peu l'hypocrite en faisant comme s'il y avait
    //plusieurs éléments dans params['passe2'] et qu'on ne savait pas que $params['etab'] était vrai
    $paramspasse2=$params['passe2'];
    if (empty($paramspasse2)) continue;
    print "<h3>Table $table</h3>";
    $nomid=$params['cle'];
    $where="";
    $select="";
    foreach($paramspasse2 as $nomforeign) {
            $where.="OR $nomforeign<0 ";
        $select.=",$nomforeign";
    }
    $where='('.substr($where,3).')'; //supprimer le 1° OR
    $select="$nomid,".substr($select,1);                    //supprimer la ,
    if ($params['etab']) $where.=" AND etab_id=$numetab";

    $res=query("SELECT $select FROM $table WHERE $where");
    while ($row=mysql_fetch_array($res)) {
        $valeurid=$row[$nomid];
        $set="";
        //la boucle qui suit est générale mais ici, elle n'a qu'un élément !
        foreach($paramspasse2 as $nomforeign) {     //$nomforeign='compte_id'
            $tabcnv=$$nomforeign;                   //$tabcnv[x]===$compte_id[x]
            $ancien=-$row[$nomforeign];
            //modif 14/04/2005 pour certains liens supprimés dans la base
            if (isset($tabcnv[$ancien]) && !empty($tabcnv[$ancien]))
                $nouveau=$tabcnv[$ancien];
            else $nouveau=0;
            $set.=",$nomforeign=$nouveau";   //$set=",compte_id=$compte_id[-ancienCompte_id]"
        }
        $set=substr($set,1); //enlever la première virgule
        //ci-dessous par ex. : UPDATE profs SET compte_id=48
        $sql="UPDATE $table SET $set WHERE $nomid=$valeurid";
        print $sql;print "<br />";
        query($sql);
    }
}
print "<hr>\n";
}

function foire($par,$vbackupx='') {
//vcorrectx est la version correcte pour restaurer, sans les centièmes (par exemple 4.6.x)
global $MODULE,$VERSION_GIBII;
print "<h3>Ce fichier ne peut pas être utilisé.</h3>";
print "<h4>";
print $par;
print "</h4>";
if ($vbackupx) {
    print "<p><em>";
    print "Pour utiliser ce backup avec cette version de GiBii, il faut quelques étapes intermédiaires...
    		<br /><br /><ul><b>Sur une machine locale :</b>

    		<li> installez une version de $MODULE $vbackupx,
    		<li> restaurez votre établissement en mode admin,</li>
    		<li> mettez les scripts de $MODULE à jour pour obtenir une version $VERSION_GIBII,</li>
    		<li> mettez la base à jour en copiant les fichiers de sadmin/maj_faite vers sadmin/maj puis en
    		  lançant la page sadmin,</li>
    		<li> effectuez un backup,</li>
    		<li> revenez ici et injectez ce backup.</li>
    		</ul>";
    print "</em></p>";
	}
exit();
}

function verifiebackup() {
global $tini,$MODULE,$VERSION_GIBII;
//récupérer les directives
//print_r($tini);
if (!isset($tini['#'])) foire("Il est antérieur à la version 4.6.1","correspondant à votre backup");

$programme=$tini['#']['module'];
if ($programme!='GiBii') foire("Ce backup n'est pas relatif à $MODULE mais à $programme");
$versionbkp=$tini['#']['version'];

$v=explode('.',$versionbkp);
$vbackupx=$v[0].'.'.$v[1].'.x';
$v=explode('.',$VERSION_GIBII);
$vgibiix=$v[0].'.'.$v[1].'x';

$vact=(int) (vbase100($VERSION_GIBII)/100);
$vbackup=(int) (vbase100($versionbkp)/100);

if ($vact-$vbackup>=1)
	foire("Ce backup est trop ancien ($versionbkp)
			alors que la version actuelle de GiBii est la $VERSION_GIBII.
			Il faut une version $vbackupx.",$vbackupx);
if ($vbackup-$vact>=1)
	foire("Ce backup a été créé par la version $versionbkp.
			Il est plus récent que la version de GiBii actuelle ($VERSION_GIBII).");
}

//-------------  ppal  -------------------
opensession('Admin',false);
connecte($host,$user,$mdp,$db);
print "<HTML><HEAD><link rel=\"stylesheet\" href=\"../themes/".$etab_theme."/b2i.css\">\n";
print "<meta http-equiv=\"content-type\" content=\"text/html; charset=ISO-8859-1\">\n";
print "<title>Backup de la base $db</title></head>\n";
print "<BODY class=\"arialadmin\">\n";
print "<p class='sous_titre'>Restauration de votre établissement</p>\n";
if (!isset($bouton)) {
    //ini_set('upload_max_filesize','4M');
    choisir();
}
else {
    set_time_limit(0);
    ini_set('file_uploads','On');         //autorise l'upload
    ini_set('upload_max_filesize','20M');

    if ($bouton==1) $nomrecu=urldecode($srvfic);
    else $nomrecu=enregistrer();
    print "<p style=\"text-align:center\">";
    if ($nomrestore=decompresser($nomrecu)) {
        $tini=parse_ini_file($nomrestore,true);   //global dans les fonctions
        verifiebackup(); 			//on peut ne pas en revenir...
        $numetab=restore_passe1();
        restore_passe2($numetab);
        print "<p><b><big>Restauration effectuée </big></b>";
        if ($etab_id==$numetab) print "pour l'établissement $etab_id";
        else print ". L'établissement a maintenant pour numéro : <big><b>$numetab</b></big>";
        print "</p><br />";
    }
    else alert("Le fichier fourni ($nomfichier)\nn'a pas l'extension voulue (sql, bz2 ou gz).");
    retour("../admin/admin_bas.php");
}
print "</body></html>";
?>