<?php
#=
/****************************************************************************
Copyright 2002, Daniel Deycard, Jacques Messines, Alain Pomirol
(CATICE Académie de Bordeaux)

This file is part of GiBii/Melia.

GiBii/Melia is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

GiBii/Melia is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GiBii/Melia; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************/

include("../include/vars_adm.php");
include("../include/util.inc.php");
include("../include/utiljs.php");
include("../include/scriptsql.php");


function choisir() {
$PHP_SELF=basename($_SERVER['PHP_SELF']);
print "<p align='center'>Indiquez un fichier de backup (extensions sql, gz et bz2 acceptées)</p>";
print "<p>&nbsp</p>";
print "<FORM method=\"post\" action=\"$PHP_SELF\" enctype=\"multipart/form-data\">\n";
print "<p align=\"center\">\n";
print "Sélectionnez le fichier qu'un précédent backup vous a fourni : ";
print "<input type=\"file\" name=\"fichier\">";
print "<input type=\"hidden\" name=\"MAX_FILE_SIZE\" VALUE=\"4000000\">";
print "&nbsp;&nbsp;\n";
print "<input type='submit' class='coul' name='bouton' value='Restaurer'>\n";
print "</FORM>\n";
print "</p>\n";
}

function erreur($mess) {   //pour le 2e passage
alert($mess);
gohistory(-1);
print "</body></html>";
exit();
}

function chksum_verif($nom) {
global $crlf;
$modele_cs='# checksum=';
$fp=fopen($nom,"r");
if (!$fp) return "impossible d'ouvrir le fichier en lecture (s'il existe !)";
$csfic=0;
$contenu='';
while (!feof($fp) && !$csfic) {
    $ligne=fgets($fp,1024);
    $m=strpos($ligne,$modele_cs);
    if ($m!==0) $contenu.=$ligne;
    else
        $csfic=substr($ligne,$m+strlen($modele_cs));
}
if (!$csfic) return "pas de somme de contrôle à la fin du fichier";
if (!feof($fp)) return "fichier incorrect : il y a du texte après la somme de contrôle";
if ($csfic!=crc32($contenu)) return "somme de contrôle incorrecte";
return "";
}

function enregistrer() {
global $etab_rne,$HIDEDATA, $nom;
$erreur="";
$copies="";
$infosfichier=$_FILES['fichier'];
//print_r($infosfichier);print "<br>";
$nom=strtolower($infosfichier['name']);
if (empty($nom)) erreur('Pas de fichier indiqué !');
$type=$infosfichier['type'];
$tmp_name=$infosfichier['tmp_name'];
$size=$infosfichier['size'];
$error=$infosfichier['error'];
if ($tmp_name=='none' || $size==0) erreur("Le fichier n'existe pas ou a une taille nulle ou trop importante.");
if ($error) erreur("Erreur $error pour $nom (tmp_name=$tmp_name)");
$dest="$HIDEDATA/$etab_rne/";
creertousrep($dest);
if (!is_dir($dest)) erreur("Impossible de créer le répertoire $dest.");
$dest.="/$nom";
if (!move_uploaded_file($tmp_name,$dest)) erreur("Erreur de copie vers $dest.");
return $dest;
}

function decompresser($nomfichier) {
global $etab_id, $etab_rne, $HIDEDATA;
if (ereg("\.(bz2|gz|sql)$" , $nomfichier, $cr)) {
    $restore="$HIDEDATA/$etab_rne/$etab_id".'_'.date('Ymd').'.sql';
    creertousrep($restore);
    switch ($cr[1]) {
        case 'bz2':
             $fbz2=bzopen($nomfichier,'r');
             $fsql=fopen($restore,'w');
             while ($s=bzread($fbz2,10000)) fwrite($fsql,$s);
             fclose($fsql);
             bzclose($fbz2);
             break;
        case 'gz':
             $fgz=gzopen($nomfichier,'r');
             $fsql=fopen($restore,'w');
             while ($s=gzread($fgz,10000)) fwrite($fsql,$s);
             fclose($fsql);
             gzclose($fgz);
             break;
        case 'sql':
             $restore=$nomfichier;
             break;
    }
}
else $restore="";
return $restore;
}

function traiter_id_negatifs (&$lsql) {
    //entrée : ligne sql ($ldsl)
    //sortie cr=0 : ok, pas de modif de la ligne
    //		 cr=1 : ok, ligne sql modifiée
    //		 cr=-1 : erreur (ne pas exécuter la requête)
    //if ($p=strpos($lsql,'compte_id') {

    //provisoire :
    return 0;

    }

//-------------  ppal  -------------------
opensession('Sadmin',false);
connecte($host,$user,$mdp,$db);
print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
print "<HTML><HEAD><link rel=\"stylesheet\" href=\"../include/general.css\">\n";
print "<meta http-equiv=\"content-type\" content=\"text/html; charset=ISO-8859-1\">\n";
print "<title>Restauration de la base $db</title></head>\n";
print "<BASE TARGET=\"_self\">\n";
print "<BODY class=\"arial_sadmin\">\n";
print "<p class='titre'>Restauration complète de la base GiBii</p><hr width=\"30%\">\n";
ini_set('file_uploads','On');         //autorise l'upload
ini_set('upload_max_filesize','80M');  //d'au plus 80 Mo (trouvé jusqu'à 63 Mo pour 60000 élèves et 400 étabs)
if (!isset($bouton)) {
    choisir();
}
else {
    set_time_limit(0);
    $nomrecu=enregistrer();
    if ($nomrestore=decompresser($nomrecu)) {
        $message=chksum_verif($nomrestore);
        if ($message)
            alert("Problème avec $nomrestore :\n$message");
        else {
            //on ne supprime plus la base car c'est parfois interdit par le prestataire
            $res=query("SHOW TABLES");
            while ($row=mysql_fetch_array($res)) {
                query("DROP TABLE $row[0]");
                }
            //query("DROP DATABASE IF EXISTS $db;");
            //query("CREATE DATABASE $db;");
            if (!SQL_execfile($nomrestore,$erreurs,"traiter_id_negatifs")) {
                print "<h3>Erreurs : </h3>";
                SQL_afferreurs($erreurs);
                print "</p>";
            }
            else print "</br></br><p align='center'>Restauration effectuée convenablement.</p>";
        }
    }
    else {
        alert("Le fichier fourni ($nom)\nn'a pas l'extension voulue (sql, bz2 ou gz).");
        choisir();
        }
    }
retour("sadmin_bas2.php");
print "</body></html>";

?>
